
/**
 * NoteHolder
 * Manages the hold mode for pads.
 * @author 3ears
 * @mail tom-buettner@t-online.de
 */
var NoteHolder = function()
{
    //SensorGroup.prototype.constructor.call( this );
    //app.noteInput.setKeyTranslationTable( initArray( -1, 128 ));  // handle midi notes self, not Bitwig API

    //this.table     = initArray( -1, 128 );
    //this.holdNotes = initArray( -1, 16 );  // tracks which notes the hold pads are playing in order to send correct note-off
    //this.playNotes = initArray( -1, 16 );  // tracks any playing notes

    //this.sensors.octave   = new RangedSensorPair( 0, -4, 6, 'octaveUp', 'octaveDown', true );
    //this.sensors.semitone = new RangedSensorPair( 0, -12, 12, 'semitoneUp', 'semitoneDown', true );
    //this.sensors.scale    = new CircleSensorPair( 0, app.scales.length, 'scaleUp', 'scaleDown' );
    //
    //this.addListener( 'octave', 'sensorOn', this, function( sensor ) {
    //    app.notify( 'Octave: ' + sensor.value );
    //    app.preferences.octaveSetting.setRaw( sensor.value );
    //    this.update();
    //});
    //this.addListener( 'semitone', 'sensorOn', this, function( sensor ) {
    //    app.notify( 'Root: ' + MidiData.getRootName( sensor.value ));
    //    app.preferences.semitoneSetting.setRaw( sensor.value );
    //    this.update();
    //});
    //this.addListener( 'scale', 'sensorOn', this, function( sensor ) {
    //    app.preferences.scaleSetting.setRaw( sensor.value );
    //    var rootNote = MidiData.getRootName( this.sensors.semitone.value );
    //    var scaleName = rootNote + ' ' + app.scales[sensor.value].name;
    //    app.notify( 'Scale: ' + scaleName );
    //    this.update();
    //});
    //
    //app.preferences.addListener( 'octave',         this, this.onPreferences );
    //app.preferences.addListener( 'semitone',       this, this.onPreferences );
    //app.preferences.addListener( 'scale',          this, this.onPreferences );
    //app.preferences.addListener( 'scalesEnabled',  this, this.update );
    //app.preferences.addListener( 'modalTranspose', this, this.update );
    //app.preferences.addListener( 'mode',           this, this.update );
};
//Midi.prototype = new SensorGroup();
//Midi.prototype.constructor = Midi;


//Transposer.prototype.update = function()
//{
//    this.updateTranslationTable();
//    this.updateLeds();
//};
//
//
///**
// * Updates the key translation table
// */
//Midi.prototype.updateTranslationTable = function()
//{
//    this.table  = initArray( -1, 128 );
//    var context = this.buildTranslationContext();
//
//    if( context.mode === 'notes' || context.mode === 'split' ) {
//        for( var i = context.padRoot; i < context.maxIndex; i++ ) {
//            this.table[i] = this.translate( i, context );
//        }
//    }
//};
//
//
///**
// * Translates the given midi numbers according to the current scale, scaleEnabled, modalTranspose and transpose state.
// * @param midiNum
// * @param context
// * @returns {number}
// */
//Midi.prototype.translate = function( midiNum, context )
//{
//    context = context || this.buildTranslationContext();
//
//    if( app.preferences.scalesEnabled ) {
//        if( app.preferences.modalTranspose)
//        {
//            this.buildLongScale();
//            var scale = app.getScale();
//            var longScale = this.longScale;
//
//            var scaleOffset = 12 - app.getSemitones();
//            //var first = 0;
//            //for( var j = scale.length; j >= 0; j-- ) {
//            //    if( scale[j] < scaleOffset ) {
//            //        first = j + 1;
//            //        break;
//            //    }
//            //}
//            var first   = app.getFirstScaleTone();
//            var offset  = midiNum - context.padRoot + first;
//            var degree  = Math.abs( offset % context.scaleLength );
//            var octave  = Math.floor( offset / context.scaleLength );
//            var note    = context.scale[ degree ];
//            var result  = context.padRoot + note + 12 * octave + app.getSemitones();
//
//            if( midiNum >= context.padRoot && midiNum < context.padRoot + 16 ) {
//                println( 'translate longScale='+longScale+' offset='+offset+' first='+first+' degree='+degree );
//            }
//            return Math.min( 127, Math.max( 0, result ));
//
//
//            //var offset  = midiNum - context.padRoot;
//                //var degree  = Math.abs( offset % context.scaleLength ) + (12-app.getSemitones());
//                //var octave  = Math.floor( offset / context.scaleLength );
//                //var note    = context.scale[ degree ];
//                //var result  = context.padRoot + note + 12 * octave + context.transpose;
//                //
//                //
//                //return Math.min( 127, Math.max( 0, result ));
//        }
//        else {
//            var offset  = midiNum - context.padRoot;
//            var degree  = Math.abs( offset % context.scaleLength );
//            var octave  = Math.floor( offset / context.scaleLength );
//            var note    = context.scale[ degree ];
//            var result  = context.padRoot + note + 12 * octave + context.transpose;
//
//            return Math.min( 127, Math.max( 0, result ));
//        }
//    }
//    else {
//        return Math.min( 127, midiNum + context.transpose );
//    }
//};
//
//
//Midi.prototype.buildLongScale = function()
//{
//    var numOctaves = 3;
//    var scale = app.getScale();
//
//    this.longScale = scale.slice( 0 );
//    var length = scale.length * numOctaves;          // enlarge scale to 3 octaves
//    for( var i = 0; i < length; i++ ) {
//        var add = 12 * Math.floor( i / scale.length );
//        this.longScale[i] = scale[i % scale.length] + add;
//    }
//};
//
//
//
///**
// * Builds the context for this.translate.
// */
//Midi.prototype.buildTranslationContext = function()
//{
//    var mode = app.getMainMode();
//    var padRoot = app.getPadRoot();
//    return {
//        mode        : mode,
//        padRoot     : padRoot,
//        scale       : app.getScale(),
//        scaleLength : app.getScale().length,
//        maxIndex    : mode === 'split' ? padRoot + 8 : 128,
//        transpose   : app.getOctave() * 12 + (app.preferences.modalTranspose ? 0: app.getSemitones() )
//    };
//};


NoteHolder.prototype.onNoteOn = function( midi )
{
    //if( app.getMode() !== 'alternate' ) {
    //    switch( midi.data1 ) {
    //        case app.layout.scaleUp.note   : this.sensors.scale.increase(); break;
    //        case app.layout.scaleDown.note : this.sensors.scale.decrease(); break;
    //    }
    //}
    //
    //switch( midi.data1 ) {
    //    case app.layout.octaveUp.note     : this.sensors.octave.increase(); break;
    //    case app.layout.octaveDown.note   : this.sensors.octave.decrease(); break;
    //    case app.layout.semitoneUp.note   : this.sensors.semitone.increase(); break;
    //    case app.layout.semitoneDown.note : this.sensors.semitone.decrease(); break;
    //}

    //var note = this.noteTable[midi.data1];
    //var maxIndex = midi.mainMode === 'split' ? 8 : 16;
    //
    //if( midi.padIndex >= 0 && midi.padIndex < maxIndex && note > -1 )
    //{
    //    if( midi.mainMode === 'notes' || midi.mainMode === 'split' )
    //    {
    //        app.transposer.setPadPressed( true );
    //
    //        this.playNotes[midi.padIndex] = note;
    //
    //        if( app.preferences.holdPads[midi.padIndex] > 0 )   // pad has hold mode enabled
    //        {
    //            var holdNote = this.holdNotes[midi.padIndex];
    //            if( holdNote >= 0 ) {
    //                this.clearHoldNote( midi.padIndex );        // clear hold
    //            }
    //            else {
    //                this.holdNotes[midi.padIndex] = note;       // set hold
    //                app.midiToBitwig( 144, note, midi.data2 );
    //            }
    //        }
    //        else {
    //            app.midiToBitwig( 144, note, midi.data2 );
    //        }
    //
    //        if( app.getMode() === 'alternate' )  // toggle hold mode for note pads
    //        {
    //            var holdPads = app.preferences.holdPads;
    //            var hold     = (holdPads[midi.padIndex] > 0) ? 0 : 1;
    //            if( hold === 0 ) {
    //                this.clearHoldNote( midi.padIndex );
    //            }
    //            this.setHoldNote( midi.padIndex, hold );
    //        }
    //    }
    //}
};


NoteHolder.prototype.onNoteOff = function( midi )
{
    //switch( midi.data1 ) {
    //    case app.layout.octaveUp.note     :
    //    case app.layout.octaveDown.note   : this.sensors.octave.onRelease(); break;
    //    case app.layout.semitoneUp.note   :
    //    case app.layout.semitoneDown.note : this.sensors.semitone.onRelease(); break;
    //    case app.layout.scaleUp.note      :
    //    case app.layout.scaleDown.note    : this.sensors.scale.onRelease(); break;
    //}

    //if( midi.padIndex >= 0 && midi.padIndex < 16 && this.noteTable[midi.data1] > -1 )
    //{
    //    app.transposer.setPadPressed( false );
    //
    //    if( this.holdNotes[midi.padIndex] === -1 ) {
    //        app.midiToBitwig( midi.status, this.noteTable[midi.data1], midi.data2 );
    //        this.playNotes[midi.padIndex] = -1;
    //    }
    //}
};


///**
// * Converts cc127 to channel aftertouch.
// * @param midi
// */
//Midi.prototype.onController = function( midi )
//{
//    if( app.getMode() !== 'clips' && app.preferences.sendPressure && midi.data1 === 127 ) {
//        app.midiToBitwig( 208, midi.data2, 0 );
//    }
//};
//
//
///**
// * Called when the app goes into alternate mode.
// * Set hold mode for pad in playing state.
// */
//Midi.prototype.onEnterAlternateMode = function()
//{
//    var maxIndex = app.getMainMode() === 'split' ? 8 : 16;
//
//    for( var i = 0; i < maxIndex; i++ ) {
//        if( this.playNotes[i] >= 0) {
//            this.holdNotes[i] = this.playNotes[i];  // set all currently playing notes to hold
//            this.setHoldNote( i, 1 );
//        }
//    }
//    app.pads.updateLeds();
//};
//

/**
 * Turns on hold state of a pad.
 * @param midi
 */
Midi.prototype.setHoldNote = function( padIndex, state )
{
    var holdPads = app.preferences.holdPads;
    if( holdPads[padIndex] !== state )
    {
        holdPads[padIndex] = state;

        app.preferences.holdSetting.set( holdPads.toString() );
        app.modeButton.onAlternateEvent();
        app.pads.updateNotePad( padIndex );
    }
};


/**
 * Sends a note-off to Bitwig for every note in this.holdNotes. Also clears the note in this.holdNotes.
 */
Midi.prototype.clearHoldNote = function( index )
{
    var note = this.holdNotes[index];
    if( note >= 0 )
    {
        app.midiToBitwig( 128, note, 0 );
        this.holdNotes[index] = -1;
    }
};



//Midi.prototype.onPreferences = function( sender, signal ) {
//    this.sensors[signal].setValue( sender[signal] );
//};


Midi.prototype.permittedModes = ['notes', 'split', 'alternate'];






