
var Semitones = function()
{
    this.semitone = 0;
    Observer.makeObserver( this );
};


Semitones.prototype.increase = function() { this.setSemitone( this.semitone + 1 ); };
Semitones.prototype.decrease = function() { this.setSemitone( this.semitone - 1 ); };


Semitones.prototype.setSemitone = function( value )
{
    this.semitone = Math.min( 12, Math.max( -12, value ));
    this.fire( 'sensorOn' );
};


Semitones.prototype.onNoteOff = function() {
    this.fire( 'sensorOff' );
};


Semitones.prototype.getLedCodes = function() {
    return { left: 0, right: 0 };
};



