

var Sliders = function()
{
    for( var i = 0; i < 8; i++ ) {
        this.sensors[i] = new Slider( 'slider' + (i + 1), i );
    }

    for( var i = 0; i < 8; i++ )
    {
        this.sensors[i].addListener( 'sensorMove', this, function( slider ) {
            app.router.setValue( slider.getIndex(), slider.getValue() );
        });
        this.sensors[i].addListener( 'doublePress', this, function( slider ) {
            app.router.resetValue( slider.getIndex() );
        });
    }
};
Sliders.prototype = new SensorGroup();
Sliders.prototype.constructor = Sliders;


Sliders.prototype.setValues = function( values )
{
    for( var i = 0; i < 8; i++ ) {
        this.sensors[i].setValue( values[i], this.isActive() );
    }
};


Sliders.prototype.onNoteOn = function( midi )
{
    if( midi.data1 >= app.layout.slider1.note && midi.data1 <= app.layout.slider8.note ) {
        this.sensors[midi.data1-1].onPress();  // this is needed to check for double press
    }
};


Sliders.prototype.onController = function( midi )
{
    if( midi.data1 >= app.layout.slider1.cc && midi.data1 <= app.layout.slider8.cc ) {
        var index = midi.data1 - app.layout.slider1.cc;
        this.sensors[index].onMove( midi.data2 );
    }
};
